## supertuxkart 1.4

=== lib/dnsc/CMakeLists.txt ===
add_library(dnsc STATIC dns.c)
