=== debian/changelog ===
supertuxkart (1.4-0.1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 13 Feb 2023 16:23:11 -0800

supertuxkart (1.4.01~ubuntu18.04.1) bionic; urgency=low

  * Auto build.

 -- Qwerty Chouskie <asdfghrbljzmkd@outlook.com>  Fri, 23 Dec 2022 01:26:29 +0000
